//	$Id: systemif.h,v 1.1 1999/08/26 08:04:38 cisc Exp $

#ifndef incl_systemif_h
#define incl_systemif_h

#include "device.h"
#include "pc88/pcinfo.h"

namespace PC8801
{

class SystemIF
{
public:
	SystemIF(void* h, const PCInfo* p);
	~SystemIF();

	int DMARead(uint bank, uint8* data, uint nbytes);
	int DMAWrite(uint bank, uint8* data, uint nbytes);

	bool MemAcquire(uint page, uint npages, void* read, void* write, uint flags);
	bool MemRelease(uint page, uint npages, uint flags);

	void* AddEvent(uint count, uint arg);
	bool DelEvent(void*);
	uint GetTime();

	void SoundUpdate();

private:
	PCInfo pcinfo;
	void* handle;
};

}


inline int PC8801::SystemIF::DMARead(uint bank, uint8* data, uint nbytes)
{
	return (*pcinfo.DMARead)(handle, bank, data, nbytes);
}

inline int PC8801::SystemIF::DMAWrite(uint bank, uint8* data, uint nbytes)
{
	return (*pcinfo.DMAWrite)(handle, bank, data, nbytes);
}

inline bool PC8801::SystemIF::MemAcquire(uint p, uint np, void* r, void* w, uint f)
{
	return (*pcinfo.MemAcquire)(handle, p, np, r, w, f);
}

inline bool PC8801::SystemIF::MemRelease(uint p, uint np, uint f)
{
	return (*pcinfo.MemRelease)(handle, p, np, f);
}

inline void* PC8801::SystemIF::AddEvent(uint count, uint arg)
{
	return (*pcinfo.AddEvent)(handle, count, arg);
}

inline bool PC8801::SystemIF::DelEvent(void* h)
{
	return (*pcinfo.DelEvent)(handle, h);
}

inline uint PC8801::SystemIF::GetTime()
{
	return (*pcinfo.GetTime)(handle);
}

inline void PC8801::SystemIF::SoundUpdate()
{
	(*pcinfo.SoundUpdate)(handle);
}

#endif // incl_systemif_h