//
//	o̓|[gƉ̃Tv
//
//	$Id$

#include "headers.h"
#include "pcinfo.h"

#define EXTDEVAPI	__declspec(dllexport)

// ----------------------------------------------------------------------------
//	ԂLq\
//
struct Sine
{
	void* handle;
	const PCInfo* pci;

	int p, s, v;
};

// ----------------------------------------------------------------------------
//	gp I/O |[g̒`
//
const int InTable[] = { 0xc0, -1 };
const int OutTable[] = { 0xc0, -1 };

// ----------------------------------------------------------------------------

uint In(void* h, uint port)
{
	Sine* sine = (Sine*) h;
	return sine->v;
}

// ----------------------------------------------------------------------------

void Out(void* h, uint port, uint data)
{
	Sine* sine = (Sine*) h;
	
	// Ă
	(*sine->pci->SoundUpdate)(sine->handle);

	sine->v = data;
}

// ----------------------------------------------------------------------------
//	g̐ݒ
// 
bool SetRate(void* h, uint rate)
{
	Sine* sine = (Sine*) h;
	sine->s = 44100 * 256 / rate;
	return true;
}

// ----------------------------------------------------------------------------
//	
// 
void Mix(void* h, int32* dest, int length)
{
	Sine* sine = (Sine*) h;
	static const int sintable[] = 
	{
		     0,    392,    784,   1173,   1560,   1943,   2322,   2695,
		  3061,   3420,   3771,   4112,   4444,   4765,   5075,   5372,
		  5656,   5927,   6184,   6425,   6651,   6861,   7055,   7231,
		  7391,   7532,   7655,   7760,   7846,   7913,   7961,   7990,
		  7999,   7990,   7961,   7913,   7846,   7760,   7655,   7532,
		  7391,   7231,   7055,   6861,   6651,   6425,   6184,   5927,
		  5656,   5372,   5075,   4765,   4444,   4112,   3771,   3420,
		  3061,   2695,   2322,   1943,   1560,   1173,    784,    392,
			 0,   -392,   -784,  -1173,  -1560,  -1943,  -2322,  -2695,
		 -3061,  -3420,  -3771,  -4112,  -4444,  -4765,  -5075,  -5372,
		 -5656,  -5927,  -6184,  -6425,  -6651,  -6861,  -7055,  -7231,
		 -7391,  -7532,  -7655,  -7760,  -7846,  -7913,  -7961,  -7990,
		 -7999,  -7990,  -7961,  -7913,  -7846,  -7760,  -7655,  -7532,
		 -7391,  -7231,  -7055,  -6861,  -6651,  -6425,  -6184,  -5927,
		 -5656,  -5372,  -5075,  -4765,  -4444,  -4112,  -3771,  -3420,
		 -3061,  -2695,  -2322,  -1943,  -1560,  -1173,   -784,   -392,
	};

	for (; length > 0; length --)
	{
		int a = (sintable[(sine->p >> 8) & 127] * sine->v) >> 8;
		sine->p += sine->s;
		dest[0] += a;			// obt@ɂ͊ɑ̉̍ʂ
		dest[1] += a;			// ܂܂Ă̂ŁuZv邱ƁI
		dest += 2;
	}
}


extern "C"
{

//	ڑ
EXTDEVAPI void* __cdecl Connect
(void* h, const PCInfo* p, DeviceInfo* di)
{
	if (di->rev != DeviceInfo::direv || di->size != sizeof(DeviceInfo))
		return 0;

	Sine* sine = new Sine;
	if (!sine)
		return 0;
	sine->handle = h;
	sine->pci = p;
	sine->v = 128;
	
	di->flags = DeviceInfo::soundsource;
	di->inport = In;
	di->inporttable = InTable;
	di->outport = Out;
	di->outporttable = OutTable;
	di->setrate = SetRate;
	di->soundmix = Mix;

//	Ԃl R[obN֐̈ƂĎg
	return reinterpret_cast<void*> (sine);
}

//	ؒf
//	h  Connect ŕԂƂƓ
EXTDEVAPI bool __cdecl Disconnect(void* h)
{
	Sine* sine = (Sine*) h;
	if (sine)
	{
		delete sine;
		return true;
	}
	return false;
}

}


BOOL APIENTRY DllMain(HANDLE hmod, DWORD rfc, LPVOID)
{
	switch (rfc)
	{
	case DLL_PROCESS_ATTACH:
		break;
	
	case DLL_THREAD_ATTACH:
		break;
	
	case DLL_THREAD_DETACH:
		break;
	
	case DLL_PROCESS_DETACH:
		break;
	}
	return true;
}


