// ---------------------------------------------------------------------------
//  M88 - PC88 emulator
//  Copyright (C) cisc 1998, 1999.
// ---------------------------------------------------------------------------
//	ʕ`֌W
// ---------------------------------------------------------------------------
//	$Id: windraw.h,v 1.10 1999/08/01 14:41:57 cisc Exp $

#if !defined(win32_windraw_h)
#define win32_windraw_h

#include "types.h"
#include "draw.h"
#include "critsect.h"

// ---------------------------------------------------------------------------

class WinDrawSub  
{
public:
	WinDrawSub() : status(0) {}
	virtual ~WinDrawSub() {}

	virtual bool Init(HWND hwnd) = 0;
	virtual void Resize(uint width, uint height) {}
	virtual bool Cleanup() = 0;
	virtual void SetPalette(PALETTEENTRY* pal) {}
	virtual void QueryNewPalette() {}
	virtual void DrawScreen(int top, int bottom, bool refresh) = 0;

	virtual bool Lock(uint8** pimage, int* pbpl) { return false; }
	virtual bool Unlock() { return true; }

	virtual void SetGUIMode(bool gui) { }
	virtual uint GetStatus() { return status; }

protected:
	uint status;
};

// ---------------------------------------------------------------------------

class WinDraw : public Draw
{
public:
	enum
	{
		width = 640, height = 400,
	};

public:
	WinDraw();
	~WinDraw();
	bool Init0(HWND hwindow);
	
// - Draw Common Interface
	bool Init(uint w, uint h, uint bpp);
	bool Cleanup();

	bool Lock(uint8** pimage, int* pbpl);
	bool Unlock();
	
	void Resize(uint width, uint height);
	void SetPalette(uint index, uint nents, const Palette* pal);
	void DrawScreen(const Region& region);

	uint GetStatus();
	
// - Unique Interface
	int GetDrawCount() { int ret = drawcount; drawcount = 0; return ret; }
	void RequestPaint();
	void QueryNewPalette(bool background);
	void Activate(bool f) { active = f; }
	
	void SetPriorityLow(bool low);
	void SetGUIFlag(bool flag);
	bool ChangeDisplayMode(bool fullscreen, bool force480 = true);
	void Refresh() { refresh = true; }

	bool CaptureScreen(uint8* dest);

private:
	enum DisplayType { None, GDI, DDWin, DDFull };
	
	void PaintWindow();
	
	uint ThreadMain();
	static uint __stdcall ThreadEntry(LPVOID arg);
	
	uint idthread;
	HANDLE hthread;
	volatile bool shouldterminate;	// XbhIv

	DisplayType drawtype;

	volatile bool drawing;			// ʂ
	bool palchanged;				// pbgύXtO
	bool drawall;					// ʑŜ
	bool refresh;
	bool active;
	bool haspalette;				// pbgĂ

	RECT drawarea;					// ̈
	int drawcount;
	int guicount;

	int screenheight;

	HWND hwnd;
	HANDLE hevredraw;
	WinDrawSub* draw;
		
	CriticalSection csdraw;
	bool locked;

	PALETTEENTRY palette[0x100];
};

#endif // !defined(win32_windraw_h)
